SystemOrganization addCategory: #'GT-Metaceller'!

Announcement subclass: #GTConfigChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

GTConfigChanged subclass: #GTConfigLoaded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 10:25'!
acceptCode: aText version: aVersion 
	aVersion methodClass compile: aText asString classified: aVersion methodCategory.
	self announce: GTConfigChanged! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:14'!
actionsForItem: anItem
	| retVal |
	retVal := OrderedCollection new.
 	retVal add: ((GLMGenericAction new) 
			action: [:list :version | self load: list selection fromVersion: version ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [:list | list selection inspect ];
			title: 'Inspect'
			yourself).
	(self isProject: anItem) ifTrue: [ retVal add: ((GLMGenericAction new) 
						action: [ :list | self fetchProject: list selection ];
						title: 'Load configuration'
						yourself) ].
	^retVal! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:19'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:18'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:04'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metaceller'.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		row: [  :r | r
				column: #configs;
				column: #versions;
				column: #packages span: 2 ];
		row: #details.
	browser transmit
		to: #configs;
		andShow: [ :a | self configurationsIn: a ].
	browser transmit
		from: #configs;
		to: #versions;
		andShow: [ :a | self versionBrowserOn: a ].
	browser transmit
		from: #configs;
		to: #details;
		andShow: [ :a | self detailsForConfiguration: a ].
	browser transmit
		from: #versions;
		to: #details;
		andShow: [ :a | self detailsForVersion: a ].
	browser transmit
		from: #versions;
		to: #packages;
		andShow: [ :a | self packageBrowserOn: a ].
	browser transmit
		from: #packages;
		to: #details;
		andShow: [ :a | self detailsForPackage: a ].
	^ browser! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 16:35'!
childrenForConfig: aConfigClass
	[ ^(self projectsForVersion: aConfigClass project stableVersion) collect: [ :each | self configForProject: each ] thenSelect: [ :each | each notNil ] ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^#() ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:15'!
childrenForItem: anItem
	^anItem children! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 13:12'!
configForProject: aSpec
	| projectReference |
	aSpec ifNil: [  ^nil ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ projectReference := aSpec projectReference ]
		ifFalse: [ projectReference := aSpec ].
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/16/2013 09:06'!
configurationsIn: a
	^ a tree
		title: 'Configurations';
		format: [ :configClass | 
					| text label version |
					label := self shortNameOf: configClass ];
		children: [ :configClass |
			 self childrenForConfig: configClass ];
		updateOn: GTConfigLoaded from: self announcer;
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousRefresh on: $r entitled: 'Refresh' with: [ :pane | self announce: GTConfigLoaded ];
		selectionAct: [ :list | list selection browse ] entitled: 'Browse implementation';
		selectionAct: [ :list | list selection project inspect ] entitled: 'Inspect'! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:20'!
detailsForConfiguration: aBrowser
	(aBrowser respondsTo: #roassal) ifTrue: [ 
		aBrowser roassal
			title: 'Imports';
			painting: [:view :config | self viewVersionMapOf: config on: view] ]
		ifFalse: [ 
			aBrowser text
				title: 'Imports';
				display: 'Please install roassal to see the imports' ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/10/2013 11:35'!
detailsForMethod: aBrowser
	aBrowser smalltalkCode
		smalltalkClass: [ :method | method methodClass ];
		display: [ :method | method asString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :method | self acceptCode: pane text method: method ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:00'!
detailsForPackage: aBrowser
	aBrowser text
		title: 'Package spec';
		display: [ :package | package asString ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:21'!
detailsForVersion: aBrowser
	aBrowser smalltalkCode
		title: 'Method';
		smalltalkClass: [ :version | version methodClass ];
		display: [ :version | version methodString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :version | self acceptCode: pane text version: version ].
	(aBrowser respondsTo: #roassal) ifTrue: [ 
		aBrowser roassal
			title: 'Dependencies';
			painting: [ :view :version | self viewDependenciesOf: version on: view ] ]
		ifFalse: [ 
			aBrowser text
				title: 'Dependencies';
				text: 'Please install roassal to view dependencies' ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 4/9/2013 16:52'!
entity 
	^ (Object subclasses select: [:each | self isMetacelloConfig: each]) sort: [:a :b | a name < b name]! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchProject: aProjectSpec
	" this seems more stable then the alternative:
			aProjectSpec resolveToLoadableSpec load.	
			that also fethces the versions we need.
	"
	aProjectSpec loadUsing: aProjectSpec loader gofer: nil.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchVersion: aVersion
	aVersion fetch.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:04'!
groupsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion groups! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/26/2013 15:52'!
helpText
	^'Metaceller is a tool for browsing and editing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Double clicking on an item spawns the configuration details.

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- bold = the stable version
- blue = the development version
- red  = the current bleeding edge
The tag shows the blessing of the configuration.

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = project
- bold = newer package in version than loaded in image
- underlined = package / project loaded in image
- italic = groups
- gray = older package in version than loaded in image
.'! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:08'!
isGroup: aSpec 
	^(aSpec isKindOf: MetacelloGroupSpec) or: [ aSpec isKindOf: GTMetacellerGroup ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 4/10/2013 14:05'!
isMetacelloConfig: anObject
	(anObject respondsTo: #isMetacelloConfig) ifTrue: [  
		(anObject className beginsWith: 'Metacello') ifFalse: [ ^anObject isMetacelloConfig ] ].
	^false! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 10:55'!
isPackage: aSpec 
	^(self isProject: aSpec) not and: [ (self isGroup: aSpec) not ]! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 15:32'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ (aSpec isKindOf: MetacelloProjectSpec) ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 13:12'!
itemsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion packagesAndProjects! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
load: aSpec fromVersion: aVersion
	aVersion load: aSpec name.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
loadVersion: aVersion
	aVersion load.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:05'!
nameForItem: anItem
	^anItem labelAsText! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 15:59'!
packageBrowserOn: aBrowser
	aBrowser tree
		title: 'Packages';
		display: [ :version | self itemsForVersion: version ];
		children: [ :item | self childrenForItem: item ];
		format: [ :item | self nameForItem: item ];
		tags: [ :spec :version | self tagsOfSpec: spec in: version ];
		dynamicActionsOnSelection: [ :list | self actionsForItem: list selection ];
		updateOn: GTConfigChanged from: self announcer.
	aBrowser tree
		title: 'Groups';
		children: [ :item | self childrenForItem: item ];
		display: [ :version | self groupsForVersion: version ];
		updateOn: GTConfigChanged from: self announcer;
		format: [ :item | self nameForItem: item ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:29'!
projectsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [ ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isProject: each ]! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/8/2013 13:45'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:36'!
tagsOfSpec: aSpec in: aVersion
	^aVersion tagsOf: aSpec! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:38'!
tagsOfVersion: aVersion
	^aVersion tags! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/8/2013 13:45'!
validCurrentVersion: version

	version isNil ifTrue: [ ^false ].
	(version respondsTo: #versionStatus) 
		ifTrue: [ "Use #respondsTo: until 1.0-beta.23 is in general use"
			^#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: version versionStatus ].
	^true! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 15:58'!
versionBrowserOn: aBrowser
	aBrowser list
		title: 'Versions';
		display: [ :config | GTMetacellerVersion versionsForConfig: config ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		tags: [ :version | self tagsOfVersion: version ];
		format: [ :version | version textLabel ].
	aBrowser list 
		title: 'Methods';
		display: [ :config | GTMetacellerVersion allMethodsForConfig: config ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		format: [ :method | method selector ].! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/9/2013 14:11'!
versionSourceFor: aVersion
	^aVersion asString! !

!GTMetaceller methodsFor: 'roassal' stamp: 'DiegoLont 4/12/2013 16:47'!
viewDependenciesOf: version on: view
	"| view |
	view := MOViewRenderer new.
	self new viewDependenciesOf: (ConfigurationOfMoose project version: 'default') on: view.
	view open"
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires
			collect: [:each | all at: each ifAbsent: [ nil ] ] 
			thenSelect: [ :each | each notNil ] ].
	view horizontalDominanceTreeLayout layered! !

!GTMetaceller methodsFor: 'roassal' stamp: 'DiegoLont 4/17/2013 13:56'!
viewVersionMapOf: configClass on: view
	| nodes edges project |
	project := configClass project.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	(Pragma allNamed: #version: in: configClass) do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)) ].
	(Pragma allNamed: #version:imports: in: configClass) do: [:prag | 
		| version imported |
		version := nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [ project version: eachImportPrag ].
			edges add: version -> imported ] ].
	view shape label text: [ :each | each versionNumber printString ].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:16'!
hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: self name.
	^ g resolved first name ~= self currentVersionInfo name! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:11'!
labelAsText	
	^ self needsSaving
			ifTrue: [ Text string: self file attribute: TextColor blue] 
			ifFalse: [ Text fromString: self file ]! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:07'!
needsSaving
	| copy |
	copy := self workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ self projectReference version spec packages packageSpecsInLoadOrder! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:12'!
labelAsText	
	^ self name, ' ', self versionString! !

!MetacelloSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ #()! !

!MetacelloSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:14'!
labelAsText	
	^ self label! !

Object subclass: #GTMetacellerItem
	instanceVariableNames: 'version referenceSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

GTMetacellerItem subclass: #GTMetacellerGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:44'!
buildChildren
	| black gray |
	gray := (self version packagesForSpecNamed: self group name) asSet.
	black := OrderedCollection new.
	[ gray notEmpty ] whileTrue: [ 
		| spec |
		spec := gray anyOne.
		gray remove: spec.
		black add: spec.
		(self isPackage: spec) ifTrue: [ 
			spec requires do: [ :reqString |
				| package |
				package := self version packageNamed: reqString ifAbsent: [ nil ].
				package 
					ifNil: [ (self version packagesForSpecNamed: reqString) do: [ :each |
						(black includes: each) ifFalse: [ gray add: each ] ] ]
					ifNotNil: [ (black includes: package) ifFalse: [ gray add: package ] ] ] ] ].
	^black! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 13:14'!
children
	^children ifNil: [ children := self buildChildren ]! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:05'!
file
	^self group file! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
group
	^self referenceSpec! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:06'!
isPackageLoaded
	^self group isPackageLoaded! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:09'!
label
	^self group label! !

!GTMetacellerGroup methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:10'!
labelAsText
	^Text string: self label attribute: TextEmphasis italic! !

!GTMetacellerItem class methodsFor: 'instance creation' stamp: 'DiegoLont 4/24/2013 14:50'!
on: aVersion spec: aSpec
	^self basicNew
		initialize: aVersion spec: aSpec;
		yourself! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:53'!
asString
	^self referenceSpec asString ! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
children
	^#()! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/24/2013 14:29'!
initialize: aVersion
	self initialize.
	version := aVersion! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/24/2013 14:49'!
initialize: aVersion spec: aSpec
	self initialize.
	version := aVersion.
	referenceSpec := aSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:37'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
labelAsText
	^self referenceSpec label! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
name
	^self referenceSpec name! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
referenceSpec
	^referenceSpec! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:30'!
version
	^version! !

!GTMetacellerItem methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:17'!
wrapperFor: aSpec version: aVersion
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: aVersion spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: aVersion spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: aVersion spec: aSpec ].
	^aSpec! !

GTMetacellerItem subclass: #GTMetacellerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:10'!
file
	^self packageSpec file! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:23'!
isLoaded
	^self packageSpec isPackageLoaded! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 11:47'!
isNewer
	(self file = self referenceSpec name) ifTrue: [  ^false ].
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^false ] ].
	^true! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 11:48'!
isOlder
	(self file = self referenceSpec name) ifTrue: [  ^false ].	" no version specified "
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^true ] ].
	^false! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 4/25/2013 09:22'!
labelAsText
	| prefix |
	prefix := ''.
	self needsSaving ifTrue: [ prefix := '* ' ].
	^(Text fromString: prefix), (Text string: self file attributes: self textAttributes)! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:15'!
needsSaving
	self packageSpec workingCopy ifNotNilDo: [ :copy | ^copy needsSaving ].
	^false! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:09'!
packageSpec
	^self referenceSpec! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 4/25/2013 11:45'!
textAttributes
	| retVal |
	retVal := OrderedCollection new.
	self isLoaded ifTrue: [ 
		retVal add: TextEmphasis underlined.
		self isNewer ifTrue: [ retVal add: TextEmphasis bold ].
		self isOlder ifTrue: [  retVal add: TextColor gray ] ].
	^retVal! !

GTMetacellerItem subclass: #GTMetacellerProjectReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
children
	" here we return the 'labels' referenced by this project "
	| projectVersion |
	self isLoaded ifFalse: [ ^#() ].
	projectVersion := self projectReference versionOrNil.
	projectVersion ifNil: [  ^#() ].
	(self projectReference loads) ifNil: [ ^projectVersion spec packages packageSpecsInLoadOrder
		collect: [ :each | self wrapperFor: each version: projectVersion ] ].
	^self projectReference loads collect: [ :each | 
			self wrapperFor: (projectVersion packageNamed: each ifAbsent: [ each ]) version: projectVersion ]
	! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:22'!
configForProject
	| projectReference |
	projectReference := self projectReference.
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:58'!
file
	^self project file! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:55'!
isLoaded
	^self configForProject notNil! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:06'!
label
	^self project label! !

!GTMetacellerProjectReference methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:06'!
labelAsText
	| attributes |
	attributes := OrderedCollection new.
	(self isLoaded) ifTrue: [ attributes add: TextEmphasis underlined ].
	attributes add: TextColor blue.
	self versionString 
		ifNil: [ ^(Text string: self  label attributes: attributes), (Text string: ' No version' attribute: TextColor red) ]
		ifNotNil: [ ^(Text string: self label attributes: attributes), (Text string: (' ', self versionString) attribute: TextColor blue) ].
	! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:50'!
project
	^self referenceSpec! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:22'!
projectReference
	self project ifNil: [  ^nil ].
	(self project isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ ^self project projectReference ]
		ifFalse: [ ^self project ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:03'!
versionString
	^self project versionString! !

Object subclass: #GTMetacellerProject
	instanceVariableNames: 'configuration project stableVersion bleedingEdge development currentVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetacellerProject class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:30'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:29'!
bleedingEdge
	^ bleedingEdge ifNil: [ bleedingEdge := self project bleedingEdge ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:24'!
checkCurrentVersion
	currentVersion ifNil: [ currentVersion := self project currentVersion ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:18'!
configuration
	^ configuration! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:22'!
currentVersion
	^ currentVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:19'!
development
	^ development ifNil: [ development := self project development ]! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:30'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:18'!
project
	^ project ifNil: [ project := configuration project ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:18'!
stableVersion
	^ stableVersion ifNil: [ stableVersion := self project stableVersion ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:34'!
version: aStringOrSymbol
	self project ifNil: [ ^nil ].
	^self project version: aStringOrSymbol! !

Object subclass: #GTMetacellerVersion
	instanceVariableNames: 'method version configuration cachedPackageMap project groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 4/18/2013 09:25'!
allMethodsForConfig: aConfiguration
	| project |
	project := (GTMetacellerProject on: aConfiguration).
	^aConfiguration methods collect: [ :each |
		self on: aConfiguration method: each project: project ]! !

!GTMetacellerVersion class methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:27'!
isValidVersion: aVersion
	aVersion pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [  ^true ] ].
	^false! !

!GTMetacellerVersion class methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:07'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:03'!
on: aConfiguration method: aMethod project: aProject
	^self basicNew
		initialize: aConfiguration method: aMethod project: aProject;
		yourself! !

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 4/17/2013 16:31'!
versionsForConfig: aConfiguration
	^self versionsForConfig: aConfiguration project: (GTMetacellerProject on: aConfiguration) ! !

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 4/17/2013 16:03'!
versionsForConfig: aConfiguration project: project
	^(aConfiguration methods
		select: [ :each | self isValidVersion: each ]
		thenCollect: [ :each | self on: aConfiguration method: each project: project ]) 
			asSortedCollection: [ :a :b | a name > b name ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:38'!
actions
	| retVal |
	retVal := OrderedCollection new.
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection inspect ];
			title: 'Inspect'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection method browse ];
			title: 'Browse method'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection load ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection fetch ];
			title: 'Fetch'
			yourself).
"
	This checks the current version, but it needs to update the ui without recreating the versions
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection checkCurrentVersion ];
			title: 'Check current version'
			yourself).
"	self isDevelopment ifTrue: [ 
	 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection update ];
			title: 'Update'
			yourself) ].
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 11:42'!
blessing
	^self version spec blessing value! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
buildGroups
	self version ifNotNil: [ ^self version groups collect: [ :each | GTMetacellerGroup on: self version spec: each ] ].
	^#()! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:28'!
checkCurrentVersion
	self project checkCurrentVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration
	^ configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration: anObject
	configuration := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:06'!
determineVersion
	self project ifNil: [  ^nil ].
	self method pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [ ^self project version: (each arguments first) ] ].
	^nil! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:38'!
fetch
	self version ifNotNil: [ self version fetch ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 14:06'!
groups
	^groups ifNil: [ groups := self buildGroups ]! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:05'!
initialize: aConfiguration method: aMethod project: aProject
	self initialize.
	method := aMethod.
	configuration := aConfiguration.
	project := aProject! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 16:16'!
isBleedingEdge
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^false
	"
	This should be this code ... but this is a bit slow
	[ ^(self project bleedingEdge = self version) ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^false ]."! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 11:44'!
isCurrent
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project currentVersion = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:50'!
isDevelopment
	^self blessing = #development! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:49'!
isDevelopmentVersion
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project development = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 13:14'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 16:10'!
isStable
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	[ ^(self project stableVersion = self version) ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^false ].! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:26'!
load
	self version ifNotNil: [ self version load ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 11:09'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method
	^ method! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method: anObject
	method := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:43'!
methodCategory
	^self method category! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodClass
	^self configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodString
	^self method asString! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 09:15'!
name
	method pragmas do: [  :each |
		(each key beginsWith: 'version') ifTrue: [ ^each arguments first ] ].
	^method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:40'!
packageNamed: aString ifAbsent: aBlock 
	self version ifNil: [ ^nil ].
	^self version packageNamed: aString ifAbsent: aBlock! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
packages
	self version ifNil: [ ^#() ].
	^self version packages! !

!GTMetacellerVersion methodsFor: 'caching' stamp: 'DiegoLont 4/22/2013 14:08'!
packagesAndGroups
	cachedPackageMap ifNil: [
		cachedPackageMap := Dictionary new.
		self version ifNotNil: [
			self groups do: [:eachGroup |
				eachGroup children do: [ :eachPackage |
					(cachedPackageMap at: eachPackage ifAbsentPut: [OrderedCollection new])
						add: eachGroup name ] ] ] ].
	^ cachedPackageMap! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:56'!
packagesAndProjects
	self version ifNil: [ ^#() ].
	^(self version spec packages packageSpecsInLoadOrder)
		collect: [ :each | self wrapperFor: each ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:47'!
packagesForSpecNamed: aVersionString 
	self version ifNotNil: [ ^self version packagesForSpecNamed: aVersionString ].
	^#()! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:07'!
project
	^project! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
projects
	self version ifNil: [ ^#() ].
	^self version projects! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:38'!
selector
	^self method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:34'!
spec
	self version ifNotNil: [ ^self version spec ].
	^nil! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:43'!
tags
	self version ifNil: [  ^#() ].
	^Array with: self blessing! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:49'!
tagsOf: aSpec
	(aSpec isKindOf: GTMetacellerItem) ifTrue: [ ^self tagsOf: aSpec referenceSpec ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec) ifTrue: [  ^self tagsOf: aSpec projectReference ].
	^self packagesAndGroups at: aSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/26/2013 15:50'!
textLabel
	| attributes |
	attributes := OrderedCollection new.
	self version ifNil: [ attributes add: TextColor red ].
	self isBleedingEdge ifTrue: [ attributes add: TextColor red  ].
	self isDevelopmentVersion ifTrue: [ attributes add: TextColor blue ].
	self isCurrent ifTrue: [ attributes add: TextEmphasis underlined ].
	self isStable ifTrue: [ attributes add: TextEmphasis bold ].
	^Text string: self name attributes: attributes! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 15:39'!
update
	self isDevelopment ifTrue: [
		MetacelloToolBox updateToLatestPackageVersionsIn: self configuration description: 'Please describe this version.' ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:18'!
version
	^ version ifNil: [ version := self determineVersion ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
version: anObject
	version := anObject! !

!GTMetacellerVersion methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:16'!
wrapperFor: aSpec
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: self spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: self spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: self spec: aSpec ].
	^aSpec
	! !
